use strictures 1;
use Test::More qw(no_plan);
use Data::Query::ExprBuilder::Identifier;
use Data::Query::Constants qw(DQ_IDENTIFIER DQ_OPERATOR DQ_VALUE);

sub expr (&) {
  _mk_expr($_[0]);
}

sub _mk_expr {
  local $_ = Data::Query::ExprBuilder::Identifier->new({
    expr => {
      type => DQ_IDENTIFIER,
      elements => [],
    },
  });
  $_[0]->()->{expr};
}

sub expr_is (&;@) {
  my $sub = shift;
  is_deeply(_mk_expr($sub), @_);
}

expr_is { $_->foo }
  {
    type => DQ_IDENTIFIER,
    elements => [ 'foo' ]
  },
  'Simple identifier ok';


expr_is { $_->foo->bar }
  {
    type => DQ_IDENTIFIER,
    elements => [ 'foo', 'bar' ]
  },
  'Nested identifier ok';

expr_is { $_->foo == 3 }
  {
    type => DQ_OPERATOR,
    operator => { perl => '==' },
    args => [
      expr { $_->foo },
      {
        type => DQ_VALUE,
        subtype => { perl => 'Scalar' },
        value => 3,
      },
    ],
  },
  'Simple equality ok';
